#include <cstdio>
#include <thrust/host_vector.h>
#include <thrust/device_vector.h>
#include <thrust/fill.h>
#include <thrust/transform.h>
#include <thrust/functional.h>

int main()
{   
    constexpr size_t n = 1'000'000;
    thrust::host_vector<float> a(n), b(n);
    thrust::fill(begin(a), end(a), 2.);
    thrust::fill(begin(b), end(b), 3.);

    /* Note: thrust::fill can be used on device vectors directly. */
    thrust::device_vector<float> a_dev = a, b_dev = b;
    thrust::transform(a_dev.begin(), a_dev.end(), b_dev.begin(),
                      b_dev.begin(), thrust::plus<float>());

    b = b_dev;

    for (int i = 0; i < 10; i++) printf("b[%d] = %f\n", i, b[i]);
}
